/*
 * $Id: CDialog.cc,v 1.3 1998/11/24 06:20:35 mac Exp mac $
 */


#include <stdio.h>		// for NULL

#include "CDialog.h"

// should be really | or special cursor die
#define CURSOR_CHAR		'|'
#define CURSOR_STR		"|"

CFont* pdlgfnt = NULL;


CDialog::CDialog( CScrnBuf* p, int x, int y, int width, int height ): 
  psb(p), iX(x), iY(y), iWidth(width), iHeight(height), 
  fVisible(false), iColor(1), iBorderColor(15), iTextColor(14),
  iEditColor(14), iEditBackColor(0) {
    abBackSave = new char[ width*height ];

    if( !pdlgfnt ) {
      pdlgfnt = new CFont;
      if( pdlgfnt )
	pdlgfnt->load( "shaded.fnt" );
    }
}

CDialog::~CDialog() {
  hide();
  //	gfx_copyscreen( physicalscreen );
  delete abBackSave;
  abBackSave = NULL;		// just in case
  psb = NULL;				// ditto
}

void
CDialog::paint() {

//   gfx_setcontext( psb->getcontext() );

  // paint it onscreen
//   gfx_fillbox( iX, iY, iWidth, iHeight, iColor );
//   gfx_rect( Rect<ushort>( iX+1, iY+1, iX+iWidth-2, iY+iHeight-2), 
// 	    iBorderColor );
  // now draw all widgets
  dlist_iter<CDialogWidget> it(widgets);
  while( it++ )
    it()->paint();
}


void 
CDialog::show() {
  if( fVisible )
    return;

  fVisible = true;
	
//   gfx_setcontext( psb->getcontext() );

  // get the back save
//   gfx_getbox( iX, iY, iWidth, iHeight, abBackSave );
	
  // now paint the box
  paint();
}

void
CDialog::hide() {
  if( !fVisible )
    return;

  fVisible = false;

//   gfx_setcontext( psb->getcontext() );

  // paint the abBackSave
//   gfx_putbox( iX, iY, iWidth, iHeight, abBackSave );
}



void
CDlgText::paint() {
  /*
    gfx_colorfont( 8, 8, dlg()->colText(), font ); 
    gfx_write( dlgx+x(), dlgy+y(), str );
    */
  fnt_write( str, pdlg->x()+x(), pdlg->y()+y(), pdlgfnt );
}

void
CDlgEdit::paint() {
  // draw the black rectangle for the edit field
  gfx_fillbox( pdlg->x()+x(), pdlg->y()+y()-1, iWidth, pdlgfnt->height()+1, 
	       dlg()->colEditBack() );

  // maybe even a gray border

  fnt_write( text(), pdlg->x()+x(), pdlg->y()+y(), pdlgfnt );
}


void
CDlgEdit::focused() {

  if( cursorPos < 0 )
    cursorPos = 0;

  bool done = false;


  while( !done ) {
    paintWithCursor();
//     gfx_copyscreen( physicalscreen );

    // get the key here
//     short by = gfx_getche();

    switch( by ) {
    case '\n':
      done = true;
      break;
    case '\b':
      if( cursorPos ) {
	strcpy( str+cursorPos-1, str+cursorPos );
	cursorPos--;
      }
      break;
    case k_LEFT:
      if( cursorPos )
	cursorPos--;
      break;
    case k_RIGHT:
      if( cursorPos < str.length() )
	cursorPos++;
      break;
    case k_HOME:
      cursorPos = 0;
      break;
    case k_END:
      cursorPos = str.length();
      break;
    default:
      if( pdlgfnt->haveDie( by&0x0ff ) ) {
	char* buf = new char[str.length()+2];
	if( !buf ) {
	  cerr << "Out of mem" << endl;
	  exit(-1);
	}
	strncpy( buf, str, cursorPos );
	buf[ cursorPos ] = ((char)by&0x0ff);
	strcpy( buf+cursorPos+1, str+cursorPos );
	str.strdup( buf );
	cursorPos++;
	delete buf;
      }
    }

    while( pdlgfnt->measure(str) + pdlgfnt->dieWidth(CURSOR_CHAR) > iWidth)
      ((char*)str)[str.length()-1] = 0;
    if( cursorPos > str.length() )
      cursorPos = str.length();
  }

  paint();				// get rid of the cursor
//   gfx_copyscreen( physicalscreen );
}

void 
CDlgEdit::paintWithCursor() {
  // draw the black rectangle for the edit field
//   gfx_fillbox( pdlg->x()+x(), pdlg->y()+y()-1, iWidth, pdlgfnt->height()+1, 
// 	       dlg()->colEditBack() );

  // maybe even a gray border

  // write text up to cursor
  fnt_write( text(), pdlg->x()+x(), pdlg->y()+y(), pdlgfnt, cursorPos );

  // write cursor
  ushort curx = pdlgfnt->measure( text(), cursorPos );
  fnt_write( CURSOR_STR, pdlg->x()+x()+curx, pdlg->y()+y(), pdlgfnt );

	// write the rest of the text after the cursor
  fnt_write( text()+cursorPos, pdlg->x()+x()+curx+
	     pdlgfnt->dieWidth( CURSOR_CHAR ), pdlg->y()+y(), pdlgfnt );
}

