/*
 *
 * $Id: CFont.cc,v 1.3 1998/11/24 06:20:35 mac Exp mac $
 */

#include <stdio.h>
#include <string.h>

#include "CFont.h"


bool
CFont::load( const char* sz ) {
  FILE* fl = fopen( sz, "rb" );
  if( !fl )
    return false;

  fontFileHeader ffh;
  fread( &ffh, sizeof(ffh), 1, fl );

  bBaseHeight = ffh.baseHeight;
  bStemHeight = ffh.stemHeight;

  //	fseek( fl, SEEK_SET, ffh.beginDataOffset );

  // should really reset dies[] to all NULLs
  memset( dies, 0, sizeof(char*) * 256 );
	
  for(;;) {
    char die, droopsBy, width, height;
    fread( &die, 1, 1, fl );
    if( feof( fl ) )
      break;
    fread( &droopsBy, 1, 1, fl );
    fread( &width, 1, 1, fl );
    fread( &height, 1, 1, fl );

    dies[die] = new char[ 3 + width*height ];
    if( !dies[die] )
      return false;

    *(dies[die]) = droopsBy;
    *(dies[die]+1) = width;
    *(dies[die]+2) = height;
    fread( dies[die]+3, width*height, 1, fl );
  }

  fclose( fl );
  return true;
}




void fnt_write( const char* sz, short x, short y, CFont* fnt, short cnt ) {

  char vcmodeOffs = 0;

  switch( fnt->vertCoordMode() ) {
  case VCOORD_TOP:
    vcmodeOffs = fnt->baseHeight();
    break;
  case VCOORD_BOTTOM:
    vcmodeOffs = -fnt->stemHeight();
    break;
  case VCOORD_BASELINE:
    vcmodeOffs = 1;
    break;
  }

  ushort count = (ushort) cnt;

  for( ushort idx=0; idx<strlen(sz); idx++ ) {

    if( !count )
      break;
    count--;

    if( fnt->die( sz[idx] ) ) {
      char *die, *buf;
      char width, height, droop;
      die = fnt->die(sz[idx]);
      droop = *(die);
      width = *(die+1);
      height = *(die+2);
      buf = die + 3;
//       gfx_putboxmask( x, y+droop-height+vcmodeOffs, width, height, buf );
      x+=width;
    }
  }
}

ushort
CFont::dieWidth( char die ) {

  ushort idx = (ushort)((uchar)die);
  if( !dies[idx] )
    return 0;

  return *(dies[idx]+1);
}
	
ushort
CFont::measure( const char* sz, char cnt ) {

  ushort res=0;

  if( !sz || !*sz || !cnt )
    return 0;

  uchar count = (uchar) cnt;

  while( count ) {
    if( !*sz )
      break;

    if( dies[*sz] )
      res += dieWidth( *sz );

    count--;
    sz++;
  }

  return res;
}

