/*
 *
 * $Id: CFont.h,v 1.1 1997/10/30 05:38:56 maciek Exp $
 *
 * $Log: CFont.h,v $
 * Revision 1.1  1997/10/30 05:38:56  maciek
 * Initial revision
 *
 * Revision 1.1  1997/08/20 18:25:54  maciek
 * CFont basic work finished
 *
 *
 */

#ifndef __CFONT_H__
#define __CFONT_H__

#include "types.h"

#define VCOORD_TOP			0
#define VCOORD_BASELINE		1
#define VCOORD_BOTTOM		2

struct fontFileHeader {
	char id[16];			// "Font file"
	uchar majVer;
	uchar minVer;
	uchar baseHeight;
	uchar stemHeight;
	ulong beginDataOffset;	// offset in file of first die
};

class CFont {
public:
	CFont(): bBaseHeight(0), bStemHeight(0), vertCoord(VCOORD_TOP) {
		for( int i=0; i<256; i++ )
			dies[i] = NULL;
	}

	bool load( const char* sz );
	char* die( uchar idx )			{ return dies[idx]; }

	uchar baseHeight()			{ return bBaseHeight; }
	uchar stemHeight()			{ return bStemHeight; }
	uchar height()				{ return bBaseHeight + bStemHeight; }

	char vertCoordMode()		{ return vertCoord; }
	char vertCoordMode( char c ){ return vertCoord = c; }

	ushort dieWidth( char die );
	ushort measure( const char* sz, char cnt=-1 );

	bool haveDie( char c )		{ return ( dies[c] )? true: false; }

private:
	uchar bBaseHeight;
	uchar bStemHeight;

	char vertCoord;

	char* dies[256];
};



// prototypes for all functions that deal with CFont
void fnt_write( const char* sz, short x, short y, CFont* fnt, short cnt=-1 );


#endif // __CFONT_H__

