/*
 * $Id: CPal.cc,v 1.5 1998/11/24 06:20:35 mac Exp mac $
 */


#include <math.h>		// ceil()
#include "CPal.h"

void
CPal::setCol( const CRGB& t ) {
  for( ushort i=0; i<256; i++ )
    rgb[i] = t;
}

void
CPal::morph( const CPal& palL, const CPal& palR, double rPctLeft ) {

  if( rPctLeft > 1 )
    rPctLeft = rPctLeft - ceil(rPctLeft);

  for( ushort i=0; i<256; i++ ) {
    rgb[i].byRed = (uchar)(palL.rgb[i].byRed * rPctLeft + 
			   palR.rgb[i].byRed * (1-rPctLeft));
    rgb[i].byGreen = (uchar)(palL.rgb[i].byGreen * rPctLeft + 
			     palR.rgb[i].byGreen * (1-rPctLeft));
    rgb[i].byBlue = (uchar)(palL.rgb[i].byBlue * rPctLeft + 
			    palR.rgb[i].byBlue * (1-rPctLeft));
  }
}

/*
 *
 * THIS SHOULD NOT BE PART OF THIS CLASS
 *
 * IT SHOULD BE A UTILITY ROUTINE OF GLOBAL SCOPE THAT TAKES A CPal
*/

bool
CPal::install() {

//   for( ushort u=0; u<256; u++ ) 
//     gfx_setpalette( u, rgb[u].byRed, rgb[u].byGreen, rgb[u].byBlue );

  return true;
}

short 
CPal::assigned() {

  uchar count=0;
  for( ushort i=0; i<256; i++ )
    if( fAssigned[i] )
      count++;
  return count;
}

short 
CPal::assign( const CRGB &r ) {

  // perhaps it is already allocated
  for( short i=0; i<256; i++ )
    if( fAssigned[i] && rgb[i]==r )
      return i;
    
  // if not allocated yet, try to allocate it now
  for( short i=0; i<256; i++ )
    if( !fAssigned[i] ) {
      fAssigned[i] = true;
      rgb[i] = r;
      return i;
    }
  return -1;
}

bool
CPal::unassign( uchar idx ) {

  if( !fAssigned[idx] )
    return false;

  fAssigned[idx]=false;

  // for safety's sake
  rgb[idx] = CRGB(0,0,0);

  return true;
}

bool
CPal::assignAll( char* buf ) {

  if( !buf )
    return false;

  memcpy( rgb, buf, 256*3 );
  for( short i=0; i<256; i++ )
    fAssigned[i] = true;

  return true;
}


int
CPal::number_of_assigned() {
  int by=0;
  for( int i=0; i<256; i++ )
    if( fAssigned[i] )
      by++;

  return by;
}



