/*
 * $Id: CPal.h,v 1.5 1998/11/24 06:20:35 mac Exp mac $
 */

#ifndef __CPAL_H__
#define __CPAL_H__

#include "types.h"

class CRGB {
public:
  uchar byRed;
  uchar byGreen;
  uchar byBlue;

public:
  CRGB(): byRed(0), byGreen(0), byBlue(0) {}
  CRGB( uchar R, uchar G, uchar B ): byRed(R), byGreen(G), byBlue(B) {}

  bool operator==( const CRGB& r ) {
    if( r.byRed==byRed && r.byGreen==byGreen && r.byBlue==byBlue )
      return true;
    return false;
  }
};

class CPal {
  CRGB rgb[256];
  bool fAssigned[256];
  
public:
  void black()		{ setCol( CRGB(0,0,0) ); }
  void white()		{ setCol( CRGB(255,255,255) ); }
  void setCol( const CRGB& );
  void morph( const CPal&, const CPal&, double rPctLeft = 0.5 );
  bool install();

  CRGB color(uchar i)	{ return rgb[i]; }

  short assigned();
  short assign( const CRGB &rgb );
  short force_assign( const CRGB &Rgb, uchar idx ) {
    fAssigned[idx] = true;
    rgb[idx] = Rgb;
    return idx;
  }
  bool unassign( uchar idx );
  bool assignAll( char* );
  int number_of_assigned( void );
  const CRGB* get_rgb( void ) const { return rgb; }
};




#endif // __CPAL_H__
