/*
 * $Id: CScrnBuf.h,v 1.5 1998/11/12 01:55:13 mac Exp $
 */

#ifndef __CSCRNBUF_H__
#define __CSCRNBUF_H__

#include <string.h>
#include <values.h>

#include "geometry.h"
#include "types.h"

class CTile;

class CScrnBuf: public urect_t {
  char*		ColBuf;
  depth_t*	ZBuf;

 public:
  CScrnBuf( ushort, ushort );
  ~CScrnBuf() {
    delete ColBuf;
    delete ZBuf;
    ColBuf = NULL;
    ZBuf = NULL;
  }

  void Clear() {
    ClearCol();
    ClearZbuf();
  }
  void ClearCol() {
    memset( ColBuf, 0x00, area() );
  }
  void ClearZbuf() { 
    for( unsigned i=0; i<area(); i++ )
      ZBuf[i] = MAXSHORT;
  }
  bool Copy( const CScrnBuf& );

  char* cbuf() {
    return ColBuf;
  }
  depth_t* zbuf() {
    return ZBuf;
  }

  void colorize( const urect_t&, uchar byColor = 0 );

  bool paint_tile( CTile* ptl, short x, short y, t_DEPTH z );
  bool paint_pixel( unsigned x, unsigned  y, uchar col );
};


void make_z_map();
void set_z_map();
void print_z_map();


#endif // __CSCRNBUF_H__
