/*
 * $Id: CViewVol.cc,v 1.7 1998/11/12 01:55:13 mac Exp $
 */

#include "CViewVol.h"

bool
CViewVolume::paint( CScrnBuf& sb ) {

  if( !pwrl )
    return false;

  ivec_t pnt_starting_left = llCell;

  while( scr_from_WCCS( pnt_starting_left, ivec_t(0,0,0) ).y
	 < viewport.p_max().y ) {
    bool x_go_down = true;
    ivec_t pnt_cur = pnt_starting_left;

    while( scr_from_WCCS( pnt_cur, ivec_t(0,0,0) ).x
	   < viewport.p_max().x+pwrl->cell_xy_width()*2 ) {

      if( pnt_cur.x >= 0 && pnt_cur.y >= 0 ) {

	CColumn* pcol = pwrl->find_col( (ushort)pnt_cur.x, (ushort)pnt_cur.y );
	if( pcol ) {

	  list<CCell*>::const_iterator it = pcol->cells().begin();
	  while( it != pcol->cells().end() ) {
	    list<CObject*>::iterator itObj = (*it)->objs().begin();
	    while( itObj != (*it)->objs().end() ) {
	      pnt_cur.z = (*it)->z();

	      ivec_t scrXY = scr_from_WCCS( pnt_cur,
		  ivec_t( (*itObj)->cell_x(), (*itObj)->cell_y(),
			  (*itObj)->cell_z()));

	      CTile* ptl = (*itObj)->tile();
	      if( !ptl ) {
		cerr << "CViewVol::paint(): object is missing a tile" << endl;
		return false;
	      }

	      ivec_t wcsXYZ = pwrl->wcs( pnt_cur,
		  ivec_t( (*itObj)->cell_x(), (*itObj)->cell_y(),
			  (*itObj)->cell_z()));

	      depth_t z = ((wcsXYZ.x < wcsXYZ.y)? wcsXYZ.y: wcsXYZ.x)*8;

	      sb.paint_tile(
		  ptl,
		  scrXY.x - ptl->img_hsx(),
		  scrXY.y - ptl->img_hsy() + ptl->img_dz(),
		  z );
	      
	      ++itObj;
	    }
	    ++it;
	  }
	}
      }

      ////////////// dots all hotspots of all cells on altitude 0
      ivec_t scrXY = scr_from_WCCS( pnt_cur, ivec_t(0,0,0) );
      sb.paint_pixel( scrXY.x, scrXY.y, 14 );

      if( x_go_down ) {
	pnt_cur.y--;
	x_go_down = false;
      } else {
	pnt_cur.x++;
	x_go_down = true;
      }
    }

    pnt_starting_left.x++;
    pnt_starting_left.y++;
  }

  return true;
}

ivec_t
CViewVolume::scr_from_WCCS( const ivec_t& WCpnt, const ivec_t& Cpnt ) const {
  long Wcs_x_del = (WCpnt.x-llCell.x) * pwrl->cell_xy_width() + Cpnt.x;
  long Wcs_y_del = (WCpnt.y-llCell.y) * pwrl->cell_xy_width() + Cpnt.y;
  long Wcs_z_del = (WCpnt.z-llCell.z) * pwrl->cell_z_height() + Cpnt.z;

  uvec_t vp_origin = viewport.p_min();

  ivec_t res;
  res.x = Wcs_x_del*2 - Wcs_y_del*2 + vp_origin.x;
  res.y = Wcs_x_del + Wcs_y_del  +  Wcs_z_del + vp_origin.y;

  return res;
}

