#include <iostream.h>

#include "CFont.h"
#include "gfx.h"
#include "CScrnBuf.h"
#include "CPal.h"
#include "pcx.h"

main( int argc, char* argv[] ) {

  if( argc != 2 ) {
    cerr << "must specify a font file" << endl;
    return -1;
  }

  CFont fnt;

  if( !fnt.load( argv[1] ) ) {
    cerr << "Couldn't read in font" << endl;
    exit(-1);
  }

  gfx_droproot();
  CScrnBuf sb( 320, 240 );
  CPal pal;

  loadPCXpalette( "font2.pcx", pal );
  gfx_on();

  pal.install();

  sb.selectcontext();
  gfx_fillbox( 0, 0, 320, 240, 9 );
  fnt_write( "a b c d e f g h i j k l m n o p q r s t u v w x y z", 10, 10, &fnt );
  fnt_write( "A B C D E F G H I J K L M N O P Q R S T U V W X Y Z", 10, 20, &fnt );
  fnt_write( "This is a simple test of the font, right here.", 10, 30, &fnt );
  fnt_write( "The quick, brown fox jumped over the lazy dogs! $%=+-", 10, 40, &fnt );

  sb.BlitToScrn();

  gfx_getch();

  gfx_off();
}



