#include "gamewin.h"

Game_window::Game_window( Display *dpy, CScrnBuf* p, const CPal& pl, CWorld* pw ):
  sbuf_window(dpy,p,pl), pworld(pw) {

  pvv = new CViewVolume( pworld );

  unsigned int win_bottom_margin = 40;
  unsigned int win_right_margin = 80;
  pvv->set_viewport( urect_t(0,win_bottom_margin,
			     win->get_width()-win_right_margin,
			     win->get_height()) );
  paint();
}

void
Game_window::paint( int x, int y, int w, int h ) {
  if (!win->ready())
    return;
  win->set_clip(x, y, w, h);	// Clip to this area.

  // paint the world, using the viewing volume into the CScrnBuf
  if( pvv ) {
    psb->Clear();
    pvv->paint( *psb );
  }
  
  win->clear_clip();

  // now blit it
  sbuf_window::paint();
}

