/*
 * wrapper for vga_* routines
 *
 * $Id: gfx.h,v 1.1 1997/10/30 05:38:56 maciek Exp $
 *
 * $Log: gfx.h,v $
 * Revision 1.1  1997/10/30 05:38:56  maciek
 * Initial revision
 *
 * Revision 1.6  1997/08/20 18:25:54  maciek
 * CFont basic work finished
 *
 * Revision 1.5  1997/08/07 17:23:50  maciek
 * put in RCS header info in files
 *
 *
 */

#ifndef __GFX_H__
#define __GFX_H__

#include <vga.h>
#include <vgagl.h>

#include <geometry.h>

//////////////////////////////////
// prototypes
void gfx_droproot();
void gfx_on( int mode = G320x240x256 );
void gfx_off();
int  gfx_getch();
short gfx_getche();
int  gfx_setpalette(int index, int red, int green, int blue);
int  gfx_drawscanline(int line, unsigned char *colors);
void gfx_line(int x1, int y1, int x2, int y2);
void gfx_line(int x1, int y1, int x2, int y2, int c);
void gfx_rect(const Rect<ushort>& rct, int c);
void gfx_rect(const Rect<ushort>& rct);
void gfx_setcolor( int c );
void gfx_pixel(int x, int y);
void gfx_write(int x, int y, const char* sz, 
					int flags= WRITEMODE_MASKED | FONT_EXPANDED );
void gfx_copytoplanar256( const unsigned char*, int, int, int, int, int );
void gfx_setcontextvirtual( int width, int height, int bpp, int bitspp, 
					void* vbuf );
GraphicsContext* gfx_allocatecontext();
void gfx_getcontext( GraphicsContext* );
void gfx_setcontext( GraphicsContext* );
void gfx_copyscreen( GraphicsContext* );
void gfx_getbox( int x, int y, int w, int h, void* buf );
void gfx_putbox( int x, int y, int w, int h, void* buf );
void gfx_putboxmask( int x, int y, int w, int h, void* buf );
void gfx_fillbox( int x, int y, int w, int h, int c );
void gfx_colorfont( int fw, int fh, int c, void* fp );

///////////////////////////////////
// externs
extern GraphicsContext *physicalscreen;
extern void* font;

/////////////////////////////////
// key defs

#define k_LEFT		(((short)'D')<<8)
#define k_RIGHT		(((short)'C')<<8)
#define k_HOME		(((short)'1')<<8)
#define k_END		(((short)'4')<<8)

#endif // __GFX_H__
