/*
 *
 * $Id: CPal.cc,v 1.4 1997/08/20 18:25:04 maciek Exp $
 *
 * $Log: CPal.cc,v $
 * Revision 1.4  1997/08/20 18:25:04  maciek
 * CFont basic work finished
 *
 * Revision 1.3  1997/08/07 17:23:50  maciek
 * put in RCS header info in files
 *
 *
 */


#include <math.h>		// ceil()
#include "CPal.h"

#include "gfx.h"		// gfx_setpalette()

void
CPal::setCol( const CRGB& t ) {
    for( ushort i=0; i<256; i++ )
        rgb[i] = t;
}

void
CPal::morph( const CPal& palL, const CPal& palR, double rPctLeft ) {

    if( rPctLeft > 1 )
        rPctLeft = rPctLeft - ceil(rPctLeft);

    for( ushort i=0; i<256; i++ ) {
        rgb[i].byRed = (uchar)(palL.rgb[i].byRed * rPctLeft + 
									palR.rgb[i].byRed * (1-rPctLeft));
        rgb[i].byGreen = (uchar)(palL.rgb[i].byGreen * rPctLeft + 
									palR.rgb[i].byGreen * (1-rPctLeft));
        rgb[i].byBlue = (uchar)(palL.rgb[i].byBlue * rPctLeft + 
									palR.rgb[i].byBlue * (1-rPctLeft));
    }
}

bool
CPal::install() {

	for( ushort u=0; u<256; u++ ) 
		gfx_setpalette( u, rgb[u].byRed, rgb[u].byGreen, rgb[u].byBlue );

    return true;
}



