/*
 *
 * $Id: CScrnBuf.h,v 1.7 1997/08/20 18:25:54 maciek Exp maciek $
 *
 * $Log: CScrnBuf.h,v $
 * Revision 1.7  1997/08/20 18:25:54  maciek
 * CFont basic work finished
 *
 * Revision 1.6  1997/08/07 17:23:50  maciek
 * put in RCS header info in files
 *
 *
 */

#ifndef __CSCRNBUF_H__
#define __CSCRNBUF_H__

#include <string.h>

#include <geometry.h>

#include "gfx.h"
#include "types.h"
#include "CPic.h"
#include "CTile.h"

class CScrnBuf {
public:

	CScrnBuf( ushort w, ushort h );
	~CScrnBuf() {
		delete ColBuf;
		delete ZBuf;
		ColBuf = NULL;
		ZBuf = NULL;
	}

	bool PaintPic( const CPic& p, ushort x, ushort y, t_DEPTH zVal =0 ) { 
		return PaintPic( &p, x, y, zVal ); 
	}
	bool PaintPic( const CPic*, ushort x, ushort y, t_DEPTH zVal =0 );
	
	bool PaintTile( const CTile*, ushort x, ushort y, t_DEPTH zVal =0 );

	void BlitToScrn();
	void Clear()			{ ClearCol(); ClearZbuf(); }
	void ClearCol()			{ memset( ColBuf, 0x00, wWidth*wHeight ); }
	void ClearZbuf() { 
		memset( ZBuf, 0x00, wWidth*wHeight*sizeof(t_DEPTH) ); 
	}
	bool Copy( const CScrnBuf& );

	char* cbuf()			{ return ColBuf; }
	t_DEPTH* zbuf()			{ return ZBuf; }

	void colRect( const Rect<ushort>&, uchar byColor = 0 );

	ushort width()			{ return wWidth; }
	ushort height()			{ return wHeight; }

	GraphicsContext* getcontext()	{ return pgc; }

	void selectcontext()	{ gfx_setcontext( pgc ); }

private:

	ushort wWidth, wHeight;

	char* ColBuf;
	t_DEPTH* ZBuf;

	GraphicsContext* pgc;
};


#endif // __CSCRNBUF_H__
