/*
 * CWorld.h
 *
 * header file for the CWorld class
 *
 * $Id: CWorld.h,v 1.5 1997/08/07 17:23:50 maciek Exp $
 *
 * $Log: CWorld.h,v $
 * Revision 1.5  1997/08/07 17:23:50  maciek
 * put in RCS header info in files
 *
 *
 */

#ifndef __CWORLD_H__
#define __CWORLD_H__

#include <fstream.h>

#include "types.h"

#include "CColumn.h"

////////////////////////////////
// forward refs
//class CColumn;

class CWorld {
public:

	CWorld(): szName(NULL), wWidth(0), wDepth(0), paCols(NULL) {}
//	CWorld( char* szFilename )		{ textLoadCommented( szFilename ); }
	~CWorld()	{ 	delete [] paCols; delete szName; 
					paCols = NULL; wWidth = wDepth = 0; }
	
	bool textLoadCommented( char* szFilename );
	bool textLoad( char* szFilename );
	bool textSave( char* szFilename );

	bool readTextPics( fstream& );
	bool readTextTiles( fstream& );
	bool readTextCols( fstream& );
	bool readTextObjs( fstream& );

	CColumn* cols() const	{ return paCols; }

	ushort width() const		{ return wWidth; }
	ushort depth() const		{ return wDepth; }

	const char* name()			{ return szName; }

private:

	char* szName;
	ushort wWidth, wDepth;
	CColumn* paCols;
};

#endif // __CWORLD_H__
