/*
 *
 * $Id: gfx.cc,v 1.6 1997/08/20 18:25:54 maciek Exp maciek $
 *
 * $Log: gfx.cc,v $
 * Revision 1.6  1997/08/20 18:25:54  maciek
 * CFont basic work finished
 *
 * Revision 1.5  1997/08/07 17:23:50  maciek
 * put in RCS header info in files
 *
 *
 */

#include "gfx.h"
#include "types.h"

///////////////////////////////////////////////////
// this defines whether vga/vgagl is invoked

#define GFX_ON


//////////////////////////////////////////////////
// globals
GraphicsContext *physicalscreen;
void* font;

///////////////////////////////////////////////////
// code

void gfx_droproot() {

#ifdef GFX_ON
	vga_init();
#endif 

}

void gfx_on( int mode ) {

#ifdef GFX_ON
    vga_setmode( mode );
    gl_setcontextvga( mode );  /* Physical screen context. */
	////////////////////////// SHOULD REALLY FREE THIS CONTEXT LATER!!!!!
    physicalscreen = gl_allocatecontext();
    gl_getcontext( physicalscreen );	

	///////////////////////// SHOULD REALLY DELETE IT LATER!!!!!!!!!
    font = new char[256 * 8 * 8 * BYTESPERPIXEL];
    gl_expandfont(8, 8, 224 + 24, gl_font8x8, font);
    gl_setfont(8, 8, font);
#endif

}

void gfx_off() {

#ifdef GFX_ON
	vga_setmode(TEXT);
#endif 

}

int gfx_getch() {

#ifdef GFX_ON
	return vga_getch();
#else
	return -1;
#endif

}

short gfx_getche() {

#ifdef GFX_ON
	short res=vga_getch() & 0x0ff;
	if( res==27 ) {			// if ESC
		vga_getch();		// waste the '['
		res = ( vga_getch() << 8 ) & 0x0ff00;
	}
	return res;
#else
	return -1;
#endif
}

int gfx_setpalette(int index, int red, int green, int blue) {

#ifdef GFX_ON
	return vga_setpalette( index, red, green, blue );
#else
	return -1;
#endif

}

int  gfx_drawscanline(int line, unsigned char *colors) {

#ifdef GFX_ON
	return vga_drawscanline( line, colors );
#else
	return -1;
#endif

}


void gfx_line(int x1, int y1, int x2, int y2) {

#ifdef GFX_ON
	vga_drawline( x1, y1, x2, y2 );
#endif
}

void gfx_line(int x1, int y1, int x2, int y2, int c) {

#ifdef GFX_ON
	gl_line( x1, y1, x2, y2, c );
#endif
}

void gfx_rect(const Rect<ushort>& rct) {
	gfx_line( rct.p1.x, rct.p1.y, rct.p1.x, rct.p2.y );
	gfx_line( rct.p1.x, rct.p1.y, rct.p2.x, rct.p1.y );
	gfx_line( rct.p2.x, rct.p2.y, rct.p1.x, rct.p2.y );
	gfx_line( rct.p2.x, rct.p2.y, rct.p2.x, rct.p1.y );
}


void gfx_rect(const Rect<ushort>& rct, int c) {
	gfx_line( rct.p1.x, rct.p1.y, rct.p1.x, rct.p2.y, c );
	gfx_line( rct.p1.x, rct.p1.y, rct.p2.x, rct.p1.y, c );
	gfx_line( rct.p2.x, rct.p2.y, rct.p1.x, rct.p2.y, c );
	gfx_line( rct.p2.x, rct.p2.y, rct.p2.x, rct.p1.y, c );
}

void gfx_setcolor( int c ) {

#ifdef GFX_ON
	vga_setcolor( c );
#endif

}


void gfx_pixel(int x, int y) {

#ifdef GFX_ON
	vga_drawpixel( x, y );
#endif

}

void gfx_write(int x, int y, const char* sz, int flags) {

	if( !sz )
		return;

#ifdef GFX_ON
	gl_setwritemode( flags );
	gl_write( x, y, (char*)sz );
#endif

}

void gfx_copytoplanar256( const uchar *a, int b, int c, 
												int d, int e, int f ) {

#ifdef GFX_ON
	vga_copytoplanar256( (uchar*)a, b, c, d, e, f );
#endif

}


void gfx_setcontextvirtual( int width, int height, int bpp, int bitspp, 
												void* vbuf ) {
#ifdef GFX_ON
	gl_setcontextvirtual( width, height, bpp, bitspp, vbuf );
#endif
}


GraphicsContext* gfx_allocatecontext() {

#ifdef GFX_ON
	return gl_allocatecontext();
#else
	return NULL;
#endif
}

void gfx_getcontext( GraphicsContext* pgc ) {

#ifdef GFX_ON
	gl_getcontext( pgc );
#endif
}

void gfx_setcontext( GraphicsContext* pgc ) {

#ifdef GFX_ON
	gl_setcontext( pgc );
#endif
}

void gfx_copyscreen( GraphicsContext* pgc ) {

#ifdef GFX_ON
	gl_copyscreen( pgc );
#endif
}

void gfx_getbox( int x, int y, int w, int h, void* buf ) {

#ifdef GFX_ON
	gl_getbox( x, y, w, h, buf );
#endif 
}

void gfx_putbox( int x, int y, int w, int h, void* buf ) {

#ifdef GFX_ON
	gl_putbox( x, y, w, h, buf );
#endif
}

void gfx_putboxmask( int x, int y, int w, int h, void* buf ) {

#ifdef GFX_ON
	gl_putboxmask( x, y, w, h, buf );
#endif
}

void gfx_fillbox( int x, int y, int w, int h, int c ) {

#ifdef GFX_ON
	gl_fillbox( x, y, w, h, c );
#endif
}

void gfx_colorfont( int fw, int fh, int c, void* fp ) {

#ifdef GFX_ON
	gl_colorfont( fw, fh, c, fp );
#endif
}

