/*
 * grabs 'pic's from a .PCX file
 *
 * $Id: picgrab.cc,v 1.5 1997/08/20 18:25:54 maciek Exp maciek $
 *
 * $Log: picgrab.cc,v $
 * Revision 1.5  1997/08/20 18:25:54  maciek
 * CFont basic work finished
 *
 * Revision 1.4  1997/08/07 17:23:50  maciek
 * put in RCS header info in files
 *
 *
 */

#include <iostream.h>

#include "CDialog.h"
#include "CGrabBuf.h"
#include "CPic.h"
#include "gfx.h"
#include <pcx.h>

#define FNAME_ARG	1

///////////////////////////
// constants
//
const width=320;
const height=240;


///////////////////////////////
// globals
//
CGrabBuf pb( width, height );

//////////////////////////////
// subroutines
//

void getObjData( char* szFName, char* dims ) {

	CDialog dlg( &pb, width-100, height-50, 100, 50 );
	dlg.addWidget( new CDlgText(&dlg,3,3, "Filename:") );
	dlg.addWidget( new CDlgText(&dlg,3,3+pdlgfnt->height()*2, 
						"Obj. dims (XxYxZ)" ) );
	CDlgEdit* pdlgedit = new CDlgEdit(&dlg,3,3+pdlgfnt->height(),80);
	dlg.addWidget( pdlgedit );
	pdlgedit->text( szFName );

	CDlgEdit* pdlged2 = new CDlgEdit(&dlg,3,3+pdlgfnt->height()*3,80);
	dlg.addWidget( pdlged2 );
	pdlged2->text( dims );

	dlg.show();
	gfx_copyscreen( physicalscreen );

	pdlgedit->focused();
	strcpy( szFName, pdlgedit->text() );
	pdlged2->focused();
	strcpy( dims, pdlged2->text() );
}


/////////////////////////////
// main
//
int main( int argc, char* argv[] ) {

	gfx_droproot();

	if( argc != FNAME_ARG+1 ) {
		cerr << "error: you need to specify a .pcx file from which to grab pics" 			<< endl;
		return -1;
	}
		
	CPal pal;

	if( !loadPCXpalette( argv[FNAME_ARG], pal ) ) {
		cerr << "error: unable to load palette from file " 
			 << argv[FNAME_ARG] << endl;
		return -2;
	}

	// erase buffer just in case the PCX is too short
	memset( pb.cbuf(), 0, width*height );

	if( !loadPCXdata( argv[FNAME_ARG], pb.cbuf(), width, height ) ) {
		cerr << "error: unable to get picture data from file "
			 << argv[FNAME_ARG] << endl;
		return -3;
	}

	gfx_on();

	pal.install();

	// now find all the pics
	Vector2<ushort> pntStart(0,0);
	ushort ucPic = 1;
	for(;;ucPic++) {

		pb.BlitToScrn();

		Rect<ushort> rct, rctPic;
		if( !pb.findPic( pntStart, rct ) )
			break;					// no more pics

		// save the whole rectangle dimensions
		rctPic = rct;

		//
		// handle that pic
		//

		// highlight the rect
		gfx_rect( rct, 2 );
		
		// get the marker
		rct.shrinkAll();
		Vector2<ushort> pntMark;
		pntMark.x = pb.scanX( rct.p1, rct.width() );
		pntMark.y = pb.scanY( rct.p1, rct.height() );

		// horizontal line
//		gfx_line( rct.p1.x, pntMark.y, rct.p2.x, pntMark.y, 1 );	
		// vertical line
//		gfx_line( pntMark.x, rct.p1.y, pntMark.x, rct.p2.y, 1 );

		// find the tightest bound on pic
		rct.shrinkAll();		// pass the Marker ticks
		pb.collapseRect( rct );
//		gfx_rect( rct, 2 );

		// should hilite the pic's bounds now

		// now get a filename from the user for this pic
		char szFname[1024];
		char szDims[128];
		strcpy( szFname, "data/pics/.pic" );
		strcpy( szDims, "" );
		getObjData( szFname+10, szDims );

		// cut out the image into a linear buffer
		char* pchImg = pb.extractRect( rct );

		// now setup and save the pic
		CPic pic;
		pic.useImage( rct.width()+1, rct.height()+1, pchImg );
		pic.dx( rct.p1.x - pntMark.x );
		pic.dy( rct.p1.y - pntMark.y -1 );
		pic.save( szFname );

		// free up the memory used for the image
		delete pchImg;

		// now erase Pic from the buffer
		pb.colRect( rctPic );

		// advance the pntStart pointer
		pntStart = rctPic.p1;
	}

	gfx_off();
}


