/*
 *
 * $Id: wrlview.cc,v 1.5 1997/08/20 18:25:54 maciek Exp maciek $
 *
 * $Log: wrlview.cc,v $
 * Revision 1.5  1997/08/20 18:25:54  maciek
 * CFont basic work finished
 *
 * Revision 1.4  1997/08/07 17:23:50  maciek
 * put in RCS header info in files
 *
 *
 */

#include "gfx.h"
#include <pcx.h>

#include "CDialog.h"
#include "CPal.h"
#include "CWorld.h"
#include "CViewVol.h"

/////////////////////////////////
// globals
//

dlist<CPic> lstPics;
dlist<CTile> lstTiles;

const int VGAMODE=G320x240x256;
//const int VGAMODE=G640x480x256;
const int VGAWIDTH=320;
const int VGAHEIGHT=240;

main() {

	gfx_droproot();

	CWorld wrl;
	if( !wrl.textLoadCommented( "data/outdoor-world.dat" ) ) {
		cerr << "Failed to load world" << endl;
		exit( -1 );
	}

	cout << "Done loading..." << endl;

	gfx_on( VGAMODE );

	CScrnBuf sb( VGAWIDTH, VGAHEIGHT );
	CPal pal;

	CViewVolume vv( &wrl );
	vv.paint( sb );

	loadPCXpalette( "outdoors.pcx", pal );
	pal.install();

	sb.BlitToScrn();
	gfx_getch();

	for( int i=0; i<10; i++ ) {
		CColumn* pcol = wrl.cols() + 4*wrl.width();
		pcol->cells()->first()->alt( pcol->cells()->first()->alt() -1 );

		sb.ClearCol();
		vv.paint( sb );
		sb.BlitToScrn();
	}

	CDialog dlg( &sb, 20, 20, 200, 60 );
//	gfx_write( 0, 0, wrl.name() );
	fnt_write( wrl.name(), 0, 0, pdlgfnt );
	dlg.addWidget( new CDlgText(&dlg,3,3,"Dlg: This is a test") );
	CDlgEdit* pdlgedit = new CDlgEdit(&dlg,3,3+pdlgfnt->height(),80);
	dlg.addWidget( pdlgedit );
	pdlgedit->text( "Rsp:blah" );
	dlg.show();
	gfx_copyscreen( physicalscreen );

	gfx_getch();

	pdlgedit->focused();

	gfx_getch();

	dlg.hide();
	gfx_copyscreen( physicalscreen );
	gfx_getch();

	gfx_off();
}
