/*
 * grabs 'pic's from a .PCX file
 *
 * $Id: picgrab.cc,v 1.9 1998/11/24 06:20:35 mac Exp mac $
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#define XK_MISCELLANY
#define XK_LATIN1
#include <X11/keysymdef.h>

#include <fstream.h>
#include <iostream.h>
#include <unistd.h> /* sleep() */

// #include "CDialog.h"
#include "CGrabBuf.h"
#include "CTile.h"
#include "pcx.h"
#include "sbufwin.h"

///////////////////////////
// constants
//
const width=320;
const height=240;
const CString strSpecFile = "specs";


///////////////////////////////
// globals
//
CGrabBuf pb( width, height );
bool fQuiet=false;
CPal gPal;

//////////////////////////////
// subroutines
//

// void getObjData( char* szFName, char* dims ) {

//   if( fQuiet )
//     return; 

//   CDialog dlg( &pb, width-100, height-50, 100, 50 );
//   dlg.addWidget( new CDlgText(&dlg,3,3, "Filename (13 chars):") );
//   dlg.addWidget( new CDlgText(&dlg,3,3+pdlgfnt->height()*2, 
// 			      "Obj. dims (X,Y,Z)" ) );
//   CDlgEdit* pdlgedit = new CDlgEdit(&dlg,3,3+pdlgfnt->height(),80);
//   dlg.addWidget( pdlgedit );
//   pdlgedit->text( szFName );

//   CDlgEdit* pdlged2 = new CDlgEdit(&dlg,3,3+pdlgfnt->height()*3,80);
//   dlg.addWidget( pdlged2 );
//   pdlged2->text( dims );

//   dlg.show();
//   //   gfx_copyscreen( physicalscreen );

//   pdlgedit->focused();
//   strcpy( szFName, pdlgedit->text() );
//   pdlged2->focused();
//   strcpy( dims, pdlged2->text() );
// }


/////////////////////////////
// main
//
int main( int argc, char* argv[] ) {
  Display* display = NULL;

  if( argc < 2 || argc > 3 ) {
    cerr << "syntax: picgrab <pcx file> [specs file]" << endl;
    return -1;
  }
		
  ifstream fin;
  if( argc==3 ) {
    fQuiet = true;
    fin.open( argv[2], IOS_IN );
    if( !fin ) {
      cerr << "error: unable to open specs file " 
	   << argv[2] << endl;
      return -3;
    }
  }

  ofstream fspecs;
  if( !fQuiet ) {
    fspecs.open( (char*)strSpecFile, IOS_OUT );
    if( !fspecs ) {
      cerr << "error: unable to open specs file for writing"
	   << endl;
      return -4;
    }
  }

  if( !loadPCXpalette( argv[1], gPal ) ) {
    cerr << "error: unable to load palette from file " 
	 << argv[1] << endl;
    return -2;
  }

  cerr << "assigned colours == " << (int)gPal.number_of_assigned() << endl;
  
  // erase buffer just in case the PCX is too short
  memset( pb.cbuf(), 0, width*height );

  if( !loadPCXdata( argv[1], pb.cbuf(), width, height ) ) {
    cerr << "error: unable to get picture data from file "
	 << argv[1] << endl;
    return -3;
  }

  if( !fQuiet ) {
    display = XOpenDisplay(NULL);
    if (!display)
      {
	cerr << "Can't open display.\n";
	exit(-1);
      }
    sbuf_window* grab_win = new sbuf_window(display,&pb,gPal);

    int quitting_time = 0;

    /*
     *	Main event loop.
     */
    while (!quitting_time) {
	XEvent event;
	char keybuf[10];
	KeySym keysym;
	XComposeStatus compose;
	XNextEvent(display, &event);
	switch (event.type) {
	  case ButtonPress: {
	    break;
	  case Expose:		// Just repaint on last expose.
	    if (event.xexpose.count == 0)
	      grab_win->show();
	    break;
	  case ConfigureNotify:	// Resize.
	    grab_win->resized(event.xconfigure.width,
			  event.xconfigure.height);
	    grab_win->paint();
	    break;
	  case KeyPress:		// Quit on any key.
	    XLookupString((XKeyEvent *) &event, 
			  keybuf, sizeof(keybuf), &keysym, &compose);
	    switch (keysym) {
	    case XK_q:
	      quitting_time = 1;
	      break;
	    case XK_p:	// Rerender image.
	      grab_win->paint();
	      grab_win->show();
	      break;
	    case XK_plus:	// Brighten.
	      cerr << "brightening" << endl;
	      grab_win->brighten(20);
	      break;
	    case XK_minus:	// Darken.
	      grab_win->brighten(-20);
	      break;
	    }
	    break;
	  }
      }
    }
    delete grab_win;
    XCloseDisplay(display);		// All done.
    return (0);
  }

//   // now find all the pics
//   Vector2<ushort> pntStart(0,0);
//   ushort ucPic = 1;
//   for(;;ucPic++) {

//     if( !fQuiet )
//       pb.BlitToScrn();

//     Rect<ushort> rct, rctPackage, rctImg;
//     if( !pb.findPic( pntStart, rct ) )
//       break;					// no more pics

//     // save the whole rectangle dimensions
//     rctPackage = rct;

//     //
//     // handle that pic
//     //

//     // highlight the rect
//     if( !fQuiet )
//       gfx_rect( rct, 1 );
		
//     // get the marker
//     rct.shrinkAll();
//     Vector2<ushort> pntMark;
//     pntMark.x = pb.scanX( Vector2<ushort>(rct.p1.x,rct.p2.y), rct.width() )
//       - rct.p1.x;
//     pntMark.y = pb.scanY( rct.p1, rct.height() ) - rct.p1.y;
//     pntMark.y = rct.height() - pntMark.y -1;
//     // as you can see, the x,y is in LL CS

//     // find the tightest bound on pic
//     rctImg = rct;
//     rctImg.shrinkAll();		// pass the Marker ticks
    
//     pb.collapseRect( rctImg );
//     rctImg.shrinkAll(-1);
//     if( !fQuiet )
//       gfx_rect( rctImg, 1 );
//     rctImg.shrinkAll();

//     // now update the pntMark based on the actual stored image data
//     pntMark.x -= rctImg.p1.x - rct.p1.x;
//     pntMark.y -= rct.p2.y - rctImg.p2.y;
    
//     // now get a filename from the user for this pic
//     char szFname[14];
//     char szDims[128];

//     if( fQuiet ) {
//       fin >> szFname >> szDims;
//     }
//     else {
//       strcpy( szFname, "" );
//       strcpy( szDims, "" );
//       getObjData( szFname, szDims );
//       fspecs << szFname << " " << szDims << endl;
//     }

//     // bail out if early if requested (no filename given for tile)
//     if( !*szFname || !*szDims ) 
//       break;

//     // cut out the image into a linear buffer
//     char* pchImg = pb.extractRect( rctImg );

//     // extract the dimensions
//     Vector3<ushort> dim;
//     dim.x = atoi( strtok( szDims, ",x" ) );
//     dim.y = atoi( strtok( NULL, ",x" ) );
//     dim.z = atoi( strtok( NULL, ",x" ) );

//     // now save the tile
//     saveTile( pchImg, rctImg.width(), rctImg.height(), pntMark.x,
// 	      pntMark.y, dim.x, dim.y, dim.z, &pal, szFname );

//     // free up the memory used for the image
//     delete pchImg;

//     // now erase Pic from the buffer
//     pb.colRect( rctPackage );

//     // advance the pntStart pointer
//     pntStart = rctPackage.p1;
//   }

//   if( !fQuiet )
//     gfx_off();
}


