#include "sbufwin.h"
#include "CScrnBuf.h"
#include "CPal.h"

sbuf_window::sbuf_window( Display* dpy, CScrnBuf* p, const CPal& pl ):
  psb(p), pal(pl), display(dpy), brightness(100) {

  // Get screen info.
  screen_num = DefaultScreen(display);

  // I'll use this maybe later
//   unsigned int display_width = DisplayWidth(display, screen_num);
//   unsigned int display_height = DisplayHeight(display, screen_num);

//   unsigned int win_width = 320;
//   unsigned int win_height = 240;
  unsigned int win_width = psb->width();
  unsigned int win_height = psb->height();
  cerr << "creating game window of size (" << win_width
       << "," << win_height << ")" << endl;
  
  // Create window 1/2 of screen size.
  win = Image_window::create(display, screen_num,
			     win_width, win_height,
			     BlackPixel(display, screen_num), 
			     WhitePixel(display, screen_num));

  // Set title. (this needs to be configurable)
  win->set_title("an SBuf window");
  
  // Indicate events we want.
  win->select_input(ExposureMask | KeyPressMask |
		    ButtonPressMask | StructureNotifyMask);

  install_palette();
  
  // Now display window.
  win->map();
}

void
sbuf_window::paint( int x, int y, int w, int h ) {
  if (!win->ready())
    return;

  // TODO: handle the case where we want to paint only a sub-region of the
  // window
  
  // blit it over to the Image_window
  win->copy8( (unsigned char*)psb->cbuf(), psb->width(), psb->height(), 0, 0 );
}

void
sbuf_window::brighten( int per ) {
  brightness += per;
  if (brightness < 20)		// Have a min.
    brightness = 20;

  install_palette();
  paint();
  show();
}

void
sbuf_window::install_palette( void ) {
  win->set_palette( (unsigned char*)pal.get_rgb(), 32, brightness );
}

