#include "imagewin.h"
#include "CPal.h"

////// class forward decl.
class CScrnBuf;
class CPal;

////// sbuf_window: Screen Buffer window (ties a X11 win to a CScrnBuf)
class sbuf_window
{
 protected:
  CScrnBuf*	psb;
  Display*	display;	// X-windows display.
  int		screen_num;
  Image_window* win;		// Window to display into.
  int		brightness;
  CPal		pal;

public:
  sbuf_window(Display*, CScrnBuf*, const CPal&);
  
  virtual ~sbuf_window()
    { delete win; }
  int get_width()
    { return win->get_width(); }
  int get_height()
    { return win->get_height(); }
  // Resize event occurred.
  void resized(unsigned int neww, unsigned int newh)
    { win->resized(display, screen_num, neww, newh); }
  void show()
    { win->show(); }
  // Paint area of image.
  virtual void paint(int x, int y, int w, int h);
  virtual void paint()			// Paint whole image.
    { sbuf_window::paint(0, 0, get_width(), get_height()); }

  // Palette stuff
  void use_palette( const CPal& new_pal ) {
    pal = new_pal;
    install_palette();
  }
  void brighten( int per);	// Brighten/darken by percentage.
  void install_palette( void );
};
