/*
 * $Id: wrlview.cc,v 1.10 1998/11/24 06:20:35 mac Exp mac $
 */
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#define XK_MISCELLANY
#define XK_LATIN1
#include <X11/keysymdef.h>

#include <iostream.h>

#include <pcx.h>

//#include "CDialog.h"
#include "CTileMgr.h"
#include "CWorld.h"
#include "CViewVol.h"

#include "gamewin.h"

////// global data
CWorld* pworld = NULL;

/////////////////////////////////
// globals
//

//dlist<CTile> lstTiles;

CPal gPal;
CTileMgr gTileMgr;

// int col_black; // put this at 0
// int col_nontransp_black; // put this anywhere BUT 0
// int col_blue;
// int col_yellow;


main() {
  // make the zmap
  make_z_map();
  //  print_z_map();

  // world instantiation
  pworld = new CWorld( 8, 32 );
  if( !pworld->textLoadCommented( "data/test.wrl" ) ) {
    cerr << "Failed to load world" << endl;
    exit( -1 );
  }

  cout << "Done loading..." << endl;
//   cout << (short)gPal.number_of_assigned()
//     << " colours allocated in gPal" << endl;


  // X11 startup
  Display *display = XOpenDisplay(NULL);
  if (!display)
    {
      cerr << "Can't open display.\n";
      exit(-1);
    }

  CScrnBuf sb( 320, 240 );
  Game_window* gwin = new Game_window(display, &sb, gPal, pworld);

  int quitting_time = 0;

  /*
   *	Main event loop.
   */
  while (!quitting_time)
    {
      XEvent event;
      char keybuf[10];
      KeySym keysym;
      XComposeStatus compose;
      XNextEvent(display, &event);
      switch (event.type)
	{
	case ButtonPress: {
	  // do a quicky speed test
	  CColumn* pcol = pworld->find_col( 3, 3 );
	  CCell* pcel = pcol->find_or_make_cell( -1 );
	  list<CObject*>::iterator it = pcel->objs().begin();
	  while( it != pcel->objs().end() ) {
	    if( !strcmp( (*it)->tile()->name(), "ow.pine" ) )
	      break;
	    ++it;
	  }

	  if( *it ) {
	    for( int i=0; i<30; i++ ) {
	      (*it)->cell_z( i );
	      gwin->paint();
	      gwin->show();
	      XFlush(display);
	    }
	  }
 	}

	  break;
	case Expose:		// Just repaint on last expose.
	  if (event.xexpose.count == 0)
	    gwin->show();
	  break;
	case ConfigureNotify:	// Resize.
	  gwin->resized(event.xconfigure.width,
			event.xconfigure.height);
	  gwin->paint();
	  break;
	case KeyPress:		// Quit on any key.
	  XLookupString((XKeyEvent *) &event, 
			keybuf, sizeof(keybuf), &keysym, &compose);
	  switch (keysym) {
	  case XK_q:
	    quitting_time = 1;
	    break;
	  case XK_p:	// Rerender image.
	    gwin->paint();
	    gwin->show();
	    break;
	  case XK_plus:	// Brighten.
	    gwin->brighten(20);
	    break;
	  case XK_minus:	// Darken.
	    gwin->brighten(-20);
	    break;
	  }
	  break;
	}
    }
  delete gwin;
  XCloseDisplay(display);		// All done.
  return (0);


  // allocate some common colours for UI
//   col_black = gPal.force_assign( CRGB(0,0,0), 0 );
//   col_nontransp_black = gPal.force_assign( CRGB(0,0,0), 31 );
//   col_blue = gPal.force_assign( CRGB(0,0,30), 1 );
//   col_yellow = gPal.force_assign( CRGB(50,50,0), 14 );
//   gPal.force_assign( CRGB(63,20,20), 12 );

  /*
     CDialog dlg( &sb, 20, 20, 200, 60 );
  //	gfx_write( 0, 0, wrl.name() );
  fnt_write( wrl.name(), 0, 0, pdlgfnt );
  dlg.addWidget( new CDlgText(&dlg,3,3,"Dlg: This is a test") );
  CDlgEdit* pdlgedit = new CDlgEdit(&dlg,3,3+pdlgfnt->height(),80);
  dlg.addWidget( pdlgedit );
  pdlgedit->text( "Rsp:blah" );
  dlg.show();
  gfx_copyscreen( physicalscreen );

  gfx_getch();

  pdlgedit->focused();

  gfx_getch();

  dlg.hide();
  gfx_copyscreen( physicalscreen );
  gfx_getch();
   */

//   gfx_off();
}

